Index: trunk/doc/manual/en_US/user_BasicConcepts.xml
===================================================================
--- trunk/doc/manual/en_US/user_BasicConcepts.xml	(revision 48917)
+++ trunk/doc/manual/en_US/user_BasicConcepts.xml	(revision 48923)
@@ -404,4 +404,17 @@
 
           <glossentry>
+            <glossterm>Drag'n'Drop</glossterm>
+            <glossdef>
+              <para>This setting allows to enable Drag and Drop: Select a file
+                on the desktop, click the left mouse button, move the mouse
+                to the VM window and release the mouse button. The file is
+                copied from the host to the guest. This feature is currently
+                only implemented for Linux guests and only for copying files
+                from the host to the guest.<footnote><para>Support
+                for Drag'n'Drop was added with VirtualBox 4.2</para></footnote></para>
+            </glossdef>
+          </glossentry>
+
+          <glossentry>
             <glossterm>Removable media: remember runtime changes</glossterm>
 
@@ -425,4 +438,6 @@
               devices. If you don't want to see the toolbar, disable this
               setting.</para>
+              <para>The second setting allows to show the toolbar at the top
+              of the screen instead of showing it at the bottom.</para>
             </glossdef>
           </glossentry>
@@ -438,4 +453,6 @@
       configuration of a virtual machine and the software that has been
       installed into it.</para>
+      <para>To insert a line break into the description text field, press
+      <emphasis>Shift+Enter</emphasis>.</para>
     </sect2>
   </sect1>
@@ -515,4 +532,29 @@
 
           <glossentry>
+            <glossterm>Pointing Device</glossterm>
+
+            <glossdef>
+              <para>The default virtual pointing devices for older guests is the
+              traditional PS/2 mouse. If set to <emphasis>USB tablet</emphasis>,
+              VirtualBox reports to the virtual machine that a USB tablet
+              device is present and communicates mouse events to
+              the virtual machine through this device. The third setting is
+              a <emphasis>USB Multi-Touch Tablet</emphasis> which is suited
+              for recent Windows guests.</para>
+
+              <para>Using the virtual USB tablet has the advantage that
+              movements are reported in absolute coordinates (instead of as
+              relative position changes), which allows VirtualBox to translate
+              mouse events over the VM window into tablet events without
+              having to "capture" the mouse in the guest as described in <xref
+              linkend="keyb_mouse_normal" />. This makes using the VM less
+              tedious even if Guest Additions are not installed.<footnote>
+                  <para>The virtual USB tablet was added with VirtualBox 3.2.
+                  Depending on the guest operating system selected, this is
+                  now enabled by default for new virtual machines.</para>
+                </footnote></para>
+            </glossdef>
+          </glossentry>
+          <glossentry>
             <glossterm>Enable I/O APIC</glossterm>
 
@@ -568,27 +610,4 @@
           </glossentry>
 
-          <glossentry>
-            <glossterm>Enable absolute pointing device</glossterm>
-
-            <glossdef>
-              <para>If enabled, VirtualBox reports to the virtual machine that
-              a USB tablet device is present and communicates mouse events to
-              the virtual machine through this device. If disabled, mouse
-              events are communicated through a traditional PS/2 virtual mouse
-              device.</para>
-
-              <para>Using the virtual USB tablet has the advantage that
-              movements are reported in absolute coordinates (instead of as
-              relative position changes), which allows VirtualBox to translate
-              mouse events over the VM window into tablet events without
-              having to "capture" the mouse in the guest as described in <xref
-              linkend="keyb_mouse_normal" />. This makes using the VM less
-              tedious even if Guest Additions are not installed.<footnote>
-                  <para>The virtual USB tablet was added with VirtualBox 3.2.
-                  Depending on the guest operating system selected, this is
-                  now enabled by default for new virtual machines.</para>
-                </footnote></para>
-            </glossdef>
-          </glossentry>
         </glosslist></para>
 
@@ -620,7 +639,8 @@
 
       <para>You should not, however, configure virtual machines to use more
-      CPU cores than you have available physically.</para>
-
-      <para>On this tab you can also set the CPU execution cap. This setting
+      CPU cores than you have available physically (real cores, no hyperthreads).</para>
+
+      <para>On this tab you can also set the <emphasis role="bold">"CPU execution
+      cap"</emphasis>. This setting
       limits the amount of time a host CPU spents to emulate a virtual CPU.
       The default setting is 100% meaning that there is no limitation. A setting
@@ -771,4 +791,14 @@
         </glossdef>
       </glossentry>
+
+      <glossentry>
+        <glossterm>Video Capture</glossterm>
+
+        <glossdef>
+          <para>Under the "Video Capture" tab you can enable video capturing
+          for this VM. Note that this feature can also be enabled/disabled
+          while the VM is executed.</para>
+        </glossdef>
+      </glossentry>
     </glosslist>
   </sect1>
@@ -956,5 +986,5 @@
     <para>On a Linux host, depending on your host configuration, you can also
     select between the OSS, ALSA or the PulseAudio subsystem. On newer Linux
-    distributions (Fedora 8 and above, Ubuntu 8.04 and above) the PulseAudio
+    distributions (Fedora 8 and above, Ubuntu 8.04 and above), the PulseAudio
     subsystem should be preferred.</para>
   </sect1>
Index: trunk/doc/manual/en_US/user_Installation.xml
===================================================================
--- trunk/doc/manual/en_US/user_Installation.xml	(revision 48917)
+++ trunk/doc/manual/en_US/user_Installation.xml	(revision 48923)
@@ -245,5 +245,5 @@
       <itemizedlist>
         <listitem>
-          <para>Qt 4.4.0 or higher;</para>
+          <para>Qt 4.6.2 or higher;</para>
         </listitem>
 
@@ -390,8 +390,8 @@
         <para>First, download the appropriate package for your distribution.
         The following examples assume that you are installing to a 32-bit
-        Ubuntu Karmic system. Use <computeroutput>dpkg</computeroutput> to
+        Ubuntu Raring system. Use <computeroutput>dpkg</computeroutput> to
         install the Debian package:</para>
 
-        <screen>sudo dpkg -i VirtualBox-3.2_$VBOX_VERSION_STRING_Ubuntu_karmic_i386.deb</screen>
+        <screen>sudo dpkg -i VirtualBox-3.2_$VBOX_VERSION_STRING_Ubuntu_raring_i386.deb</screen>
 
         <para>You will be asked to accept the VirtualBox Personal Use and
@@ -467,5 +467,5 @@
           <listitem>
             <para>It creates
-            <computeroutput>/etc/udev/rules.d/10-vboxdrv.rules</computeroutput>,
+            <computeroutput>/etc/udev/rules.d/60-vboxdrv.rules</computeroutput>,
             a description file for udev, if that is present, which makes the
             USB devices accessible to all users in the
Index: trunk/doc/manual/en_US/user_Networking.xml
===================================================================
--- trunk/doc/manual/en_US/user_Networking.xml	(revision 48917)
+++ trunk/doc/manual/en_US/user_Networking.xml	(revision 48923)
@@ -142,4 +142,15 @@
             Windows file sharing (see <xref linkend="nat-limitations" /> for
             details).</para>
+          </glossdef>
+        </glossentry>
+
+        <glossentry>
+          <glossterm>NAT Network</glossterm>
+
+          <glossdef>
+            <para>The NAT network is a new NAT flavour introduced in
+              VirtualBox 4.3. See
+              <xref linkend="network_nat_service" xrefstyle="template: %n" />
+              for details.</para>
           </glossdef>
         </glossentry>