Index: trunk/src/bldprogs/filesplitter.cpp
===================================================================
--- trunk/src/bldprogs/filesplitter.cpp	(revision 48958)
+++ trunk/src/bldprogs/filesplitter.cpp	(revision 48959)
@@ -40,5 +40,5 @@
 /**
  * Calculates the line number for a file position.
- *  
+ *
  * @returns Line number.
  * @param   pcszContent         The file content.
@@ -48,5 +48,5 @@
 {
     unsigned long cLine = 0;
-    while (   *pcszContent 
+    while (   *pcszContent
            && (uintptr_t)pcszContent < (uintptr_t)pcszPos)
     {
@@ -63,6 +63,6 @@
 
 /**
- * Writes an error message. 
- *  
+ * Writes an error message.
+ *
  * @returns RTEXITCODE_FAILURE.
  * @param   pcszFormat          Error message.
@@ -83,6 +83,6 @@
 
 /**
- * Opens the makefile list for writing. 
- *  
+ * Opens the makefile list for writing.
+ *
  * @returns Exit code.
  * @param   pcszPath            The path to the file.
@@ -110,6 +110,6 @@
 
 /**
- * Adds the given file to the makefile list. 
- *  
+ * Adds the given file to the makefile list.
+ *
  * @returns Exit code.
  * @param   pFile               The file stream of the makefile list.
@@ -132,6 +132,6 @@
 
 /**
- * Closes the makefile list. 
- *  
+ * Closes the makefile list.
+ *
  * @returns Exit code derived from @a rc.
  * @param   pFile               The file stream of the makefile list.
@@ -148,6 +148,6 @@
 
 /**
- * Reads in a file. 
- *  
+ * Reads in a file.
+ *
  * @returns Exit code.
  * @param   pcszFile            The path to the file.
@@ -199,7 +199,7 @@
 
 /**
- * Checks whether the sub-file already exists and has the exact 
- * same content. 
- *  
+ * Checks whether the sub-file already exists and has the exact
+ * same content.
+ *
  * @returns @c true if the existing file matches exactly, otherwise @c false.
  * @param   pcszFilename    The path to the file.
@@ -209,5 +209,5 @@
 static bool compareSubFile(const char *pcszFilename, const char *pcszSubContent, size_t cchSubContent)
 {
-    struct stat     FileStat;             
+    struct stat     FileStat;
     if (stat(pcszFilename, &FileStat))
         return false;
@@ -230,6 +230,6 @@
 
 /**
- * Writes out a sub-file. 
- *  
+ * Writes out a sub-file.
+ *
  * @returns exit code.
  * @param   pcszFilename    The path to the sub-file.
@@ -258,8 +258,8 @@
 /**
  * Does the actual file splitting.
- *  
+ *
  * @returns exit code.
  * @param   pcszOutDir      Path to the output directory.
- * @param   pcszContent     The content to split up. 
+ * @param   pcszContent     The content to split up.
  * @param   pFileList       The file stream of the makefile list.  Can be NULL.
  */
@@ -292,5 +292,5 @@
         const char *pcszEndQuote = (const char *)memchr(pcszStartFilename, '\"', pcszLineAfterBegin - pcszStartFilename);
         if (!pcszEndQuote)
-            return printErr("Can't parse filename after begin-file marker (line %lu).\n", 
+            return printErr("Can't parse filename after begin-file marker (line %lu).\n",
                             lineNumber(pcszContent, s_szBeginMarker));
 
@@ -298,5 +298,5 @@
         const char *pcszEnd = strstr(pcszLineAfterBegin, s_szEndMarker);
         if (!pcszEnd)
-            return printErr("No matching end-line marker for begin-file marker found (line %lu).\n", 
+            return printErr("No matching end-line marker for begin-file marker found (line %lu).\n",
                             lineNumber(pcszContent, s_szBeginMarker));
 
@@ -329,5 +329,5 @@
     } while (rc == 0 && pcszSearch);
 
-    printf("filesplitter: Out of %lu files: %lu rewritten, %lu unchanged. (%s)\n", 
+    printf("filesplitter: Out of %lu files: %lu rewritten, %lu unchanged. (%s)\n",
            cFilesWritten + cFilesUnchanged, cFilesWritten, cFilesUnchanged, pcszOutDir);
     return rc;
Index: trunk/src/bldprogs/scmstream.cpp
===================================================================
--- trunk/src/bldprogs/scmstream.cpp	(revision 48958)
+++ trunk/src/bldprogs/scmstream.cpp	(revision 48959)
@@ -1359,4 +1359,2 @@
 }
 
-
-
Index: trunk/src/bldprogs/scmsubversion.cpp
===================================================================
--- trunk/src/bldprogs/scmsubversion.cpp	(revision 48958)
+++ trunk/src/bldprogs/scmsubversion.cpp	(revision 48959)
@@ -1060,4 +1060,2 @@
 }
 
-
-